package org.ifit.demos;

import lejos.nxt.ColorSensor;
import lejos.nxt.LCD;
import lejos.nxt.Motor;
import lejos.nxt.SensorPort;
import lejos.nxt.Sound;
import lejos.nxt.TouchSensor;
import lejos.nxt.UltrasonicSensor;
import lejos.robotics.Color;
import lejos.robotics.RegulatedMotor;
import lejos.robotics.navigation.DifferentialPilot;
import lejos.util.Delay;

public class Shooterbot {
	public static void main(String[] args) {
		final DifferentialPilot pilot = new DifferentialPilot(3.4,  12.75, Motor.C, Motor.B);
		final RegulatedMotor motorA = Motor.A;
		final UltrasonicSensor ultrasonicSensor = new UltrasonicSensor(SensorPort.S4);
		final ColorSensor colorSensor = new ColorSensor(SensorPort.S3);
		final TouchSensor touchSensor = new TouchSensor(SensorPort.S1);
		
		Thread listener = new Thread(new Runnable() {
			@Override
			public void run() {
				while (!touchSensor.isPressed()) {}				
				System.exit(0);
			}			
		});
		listener.start();
				
		while (true) {
			LCD.clear();
			colorSensor.setFloodlight(Color.GREEN);
			pilot.rotateLeft();
	
			while (ultrasonicSensor.getDistance() > 30) {
				Delay.msDelay(100);
			}
			
			colorSensor.setFloodlight(Color.RED);
			pilot.stop();
			pilot.rotate(-30);
	
			for (int i = 0; i < 3; i++) {
				Sound.beep();
				LCD.drawString(String.valueOf(3 - i), 0, 0);
				Delay.msDelay(1000);
			}
			
			if (ultrasonicSensor.getDistance() < 30) {
				LCD.drawString("Game over!", 0, 0);
				motorA.rotate(360 * 3);
			}
		}
	}
}